//
//  graph_utilities.h
//  
//
//  Created by Ivaylo Dobrikov on 06/02/14.
//
//

#ifndef _graph_utilities_h
#define _graph_utilities_h

#include "tarjan.h"
#include "hash_table_utilities.h"

typedef struct {
    unsigned int atomid;
    int graphid;
} GraphVertex;

struct vertex_node {
    GraphVertex vertex;
    struct vertex_node *next;
};

// new type for presenting vertex lists as linked lists
typedef struct vertex_node* vertex_list;

typedef struct {
    GraphVertex src;
    GraphVertex dst;
} GraphEdge;

struct edge_node {
    GraphEdge edge;
    struct edge_node *next;
};

// new type for presenting edge lists as linked lists
typedef struct edge_node* edge_list;

typedef struct {
    
    vertex_list vertices;
    edge_list edges;
    
} Graph;

#ifdef __cplusplus
extern "C" {
#endif
    vertex_list insert_vertex(vertex_list head, GraphVertex v);
#ifdef __cplusplus
}
#endif

void init_mallocs_graph_counter();
void assert_open_mallocs_graph_are_zero();
Graph get_scc_graph(tarjandata *t, int *atomids, int *len, int scc_size);
void delete_graph_data(Graph* g);
void delete_scc_components_data(Graph* scc_components, int num);
int empty_graph(Graph g);

#endif
