#ifndef MPRINTER_H_INCLUDED
#define MPRINTER_H_INCLUDED

#include "../../../lib/include/zmq.h"
#include "../../../lib/include/czmq.h"


#define DEBUG_NORMAL 20
#define DEBUG_VERBOSE 19
#define DEBUG_VERY_VERBOSE 5

extern int debug_level;
extern void *global_printer;

void init_master_printer(zctx_t *ctx, int debug_level, zmq_pollitem_t *poller,
                  int port_start, char *logfile);
void stop_master_printer(zctx_t *ctx);
//int h_prints (zloop_t *loop, zmq_pollitem_t *poller, void *arg);
void start_printer(pthread_t *thread);

/*#define DEBUG_PRINT(S, L) if (debug_level >= (L)) { \
                              struct timeval _tmpgt; \
                              gettimeofday(&_tmpgt, NULL); \
                              int _timestamp = ((int)_tmpgt.tv_sec * 1000) + (int)(_tmpgt.tv_usec/1000); \
                              zstr_sendf(global_printer, "{:type :debug :source :master :level %d :timestamp %d %s}\n", (L), _timestamp, (S)); \
                          }*/
#define DEBUG_PRINT(Level, Pre, Post, ...) \
    if ((Level) >= debug_level) { \
        Pre \
        struct timeval tmpgt; \
        gettimeofday(&tmpgt, NULL); \
        long int timestamp = ((long int)tmpgt.tv_sec * 1000) + (int)(tmpgt.tv_usec/1000); \
        int len; \
        len = snprintf(NULL, 0, __VA_ARGS__); \
        char *buf1 = malloc(len + 1 + 2); \
        snprintf(buf1, len + 1, __VA_ARGS__); \
        buf1[len] = '}'; \
        buf1[len+1] = '\n'; \
        buf1[len+2] = 0; \
        int len2; \
        len2 = snprintf(NULL, 0, "{:type :debug :source :master :level %d :timestamp %ld ", (Level), timestamp); \
        char *buf2 = malloc(len2 + len + 2 + 1); \
        snprintf(buf2, len2 + 1, "{:type :debug :source :master :level %d :timestamp %ld ", (Level), timestamp); \
        strcat(buf2, buf1); \
        zstr_send(local_printer, buf2); \
        free(buf1); \
        free(buf2); \
        Post \
    }

#endif
