#include "../include/zmq.h"
#include "../include/czmq.h"

#include "CuTest.h"
#include "../worker/wctrl.h"

extern zctx_t *ctx;
static void *tmp_socket;
extern int port;


static void init(void) {
    zmq_pollitem_t ctrl_poller;
    init_recv_control(ctx, &ctrl_poller, "localhost", port-7);
    tmp_socket = zsocket_new(ctx, ZMQ_PUB);
    zsocket_bind (tmp_socket, "tcp://*:%d", port);
    port++;
    sleep(1);
}

static void teardown(void) {
    teardown_recv_control(ctx);
    zsocket_destroy(ctx, tmp_socket);
}

void Test_ctrl_term(CuTest *cu) {
    init();

    zstr_send(tmp_socket, "TERM");
    int rc = h_control(NULL, NULL, NULL);
    CuAssertIntEquals(cu, -1, rc);

    zstr_send(tmp_socket, "FOO");

    rc = h_control(NULL, NULL, NULL);
    CuAssertIntEquals(cu, 0, rc);
    teardown();
}
