#include <assert.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "../../../lib/include/zmq.h"
#include "../../../lib/include/czmq.h"

#include <sicstus/sicstus.h>

#include "../../../common/memusage.h"

#include "wctrl.h"
#include "wdebug.h"

static void *recv_control = NULL;
static SP_pred_ref pred_stats;

extern char *worker_id;

void init_recv_control(zctx_t *ctx, zmq_pollitem_t *poller, char *masteraddr, int port, SP_pred_ref stats) {
    DEBUG_PRINT(DEBUG_VERY_VERBOSE,,,":enter :init_recv_control");
    assert(recv_control == NULL);
    recv_control = zsocket_new(ctx, ZMQ_SUB);
    //zsocket_connect(recv_control,"tcp://%s:%i", masteraddr, port+7);
    zsocket_connect(recv_control, "ipc:///tmp/zmq-proxy-%i", port+7);
    char *filter = "";
    zmq_setsockopt (recv_control, ZMQ_SUBSCRIBE, filter, strlen (filter));

    *poller = (zmq_pollitem_t) { recv_control, 0, ZMQ_POLLIN };
    DEBUG_PRINT(DEBUG_VERY_VERBOSE,,,":exit :init_recv_control");

    pred_stats = stats;
}

void teardown_recv_control(zctx_t *ctx) {
    assert(recv_control != NULL);
    zsocket_destroy(ctx, recv_control);
    recv_control = NULL;
}



int h_control(zloop_t *loop, zmq_pollitem_t *poller, void *arg) {
    DEBUG_PRINT(DEBUG_VERY_VERBOSE,,,":enter :h_control");
    zmsg_t *msg = zmsg_recv(recv_control);
    char *str = zmsg_popstr (msg);
    zmsg_destroy(&msg);
    if (strcmp(str, "TERM") == 0) {
        DEBUG_PRINT(DEBUG_VERY_VERBOSE,,,":exit :h_control :signal %s", str);
        free(str);
        return -1;
    } else if (strcmp(str, "MEMORY") == 0) {
        DEBUG_PRINT(DEBUG_NORMAL,,, ":memory %ld", memory_usage_in_kb());
        SP_term_ref ref = SP_new_term_ref();
        SP_put_string(ref, worker_id);
        int status = SP_query_cut_fail(pred_stats, ref);
        assert(status == SP_SUCCESS);
    }
    free(str);
    DEBUG_PRINT(DEBUG_VERY_VERBOSE,,,":exit :h_control");
    return 0;
}
