% (c) 2009-2015 Lehrstuhl fuer Softwaretechnik und Programmiersprachen, 
% Heinrich Heine Universitaet Duesseldorf
% This software is licenced under EPL 1.0 (http://www.eclipse.org/org/documents/epl-v10.html) 

:- module(zenvironment,
          [lookup_type/3
          ,create_subenv/3
          ,env_z_defs/2
          ,zlookup/2
          ,zlookup_schema/4
          %,create_scope_typeinfos/2
          %,lookup_typeinfo/5
          %,all_schemas/2
          ,create_initial_zenvironment/2
          ]).


:- use_module(probsrc(module_information)).
:- module_info(group,proz).
:- module_info(description,'This module provides predicates to access a type environment for Z specifications.').

lookup_type(env(_,Vars),Var,Type) :- member(variable(Var,T),Vars),!,T=Type.
lookup_type(env(Up,_),Var,Type) :- lookup_type(Up,Var,Type).

%all_schemas(Env,Names) :- env_z_defs(Env,Defs),findall(Name,zlookup_schema2(Defs,Name,[],_),Names).

zlookup_schema(Env,Name,Params,Expr) :- env_z_defs(Env,Defs),zlookup_schema2(Defs,Name,Params,Expr),!.
zlookup_schema2(Defs,Name,Params,Expr) :- member(sdef(shead(Name,Params),Expr),Defs).
zlookup_schema2(Defs,Name,Params,Expr) :- member(defeq(shead(Name,Params),Expr),Defs).
zlookup_schema2(Defs,Name,Params,Expr) :- member(eqeq(lhs(Name,Params),Expr),Defs).

zlookup(Env,Entry) :- env_z_defs(Env,D),member(Entry,D).

create_initial_zenvironment(Defs,zdef(Defs)).

env_z_defs(zdef(D),D).
env_z_defs(env(Up,_),D) :- env_z_defs(Up,D).

create_subenv(Env,Vars,env(Env,Vars)).

%create_scope_typeinfos(Env,tenv(TI)) :-
%    Env = env(_,Vars),
%    findall(tinfo(Name,_Expr,Env,Type), member(variable(Name,Type),Vars), TI).

%lookup_typeinfo(tenv(Tenv),Name,Expr,Env,Type) :-
%    member(tinfo(Name,Expr,Env,Type),Tenv).
