:- multifile generate/2.

:- use_module(probsrc(bsyntaxtree),[find_typed_identifier_uses/2]).
:- use_module(synthesis(synthesis_util),[find_typed_identifier_uses_with_info/2]).

% return explicit bindings as terms bind/2 and the used identifier nodes
generate(prob_state_bindlist(AST),Bindings:TypedIDs) :-
    find_typed_identifier_uses_with_info(AST,TypedIDs) ,
    maplist(ast_ids_to_bindlist,TypedIDs,Bindings) , !.
% unbound bindlist
generate(prob_state_bindlist(AST,Options),Bindings:TypedIDs) :-
    member(unbound,Options) ,
    find_typed_identifier_uses_with_info(AST,TypedIDs) ,
    findall(bind(ID,_),member(b(identifier(ID),_,_),TypedIDs),Bindings) , !.

% generate a binding for an identifier
ast_ids_to_bindlist(b(identifier(Name),record(_),_),bind(Name,[])).
ast_ids_to_bindlist(b(identifier(Name),seq(integer),_),bind(Name,Value)) :-
        generate(prob_value_seq([]),Value).
ast_ids_to_bindlist(b(identifier(Name),set(integer),_),bind(Name,Value)) :-
        generate(prob_value_set([]),Value).
ast_ids_to_bindlist(b(identifier(Name),Type,_),bind(Name,Value)) :-
    % add options to inner type for generation
    inner_type(Type,Inner,Outter) ,
    % options for integer, other types ignore this option
    NewInner =.. [Inner,[small,positive,nozero]] ,
    surround_type(NewInner,Outter,TempType) ,
    gen_type(TempType,value,NewType) ,
    generate(NewType,Value).
